Index: common/libs/func_wrt_Makefile
===================================================================
--- common/libs/func_wrt_Makefile	(revision 111d25a4a5c1340fc3d829d2843259bd3ff1992b)
+++ common/libs/func_wrt_Makefile	(revision 41d8577919139d848cacbfd5fb2810e59658229d)
@@ -18,24 +18,16 @@
 SHELL = /bin/bash
 
+MOUNT_PT       = $BUILDDIR
+SCRIPT_ROOT    = $SCRIPT_ROOT
+CMDSDIR        = $PROGNAME-commands
 SRC            = /sources
-MOUNT_PT       = $BUILDDIR
+SRCSDIR        = \$(MOUNT_PT)\$(SRC)
+FILELOGDIR     = /\$(SCRIPT_ROOT)/$FILELOGDIRBASE
+
 LUSER          = $LUSER
 LGROUP         = $LGROUP
 LHOME          = $LHOME
-SCRIPT_ROOT    = $SCRIPT_ROOT
-
-BASEDIR        = \$(MOUNT_PT)
-SRCSDIR        = \$(BASEDIR)/sources
-CMDSDIR        = \$(BASEDIR)/\$(SCRIPT_ROOT)/$PROGNAME-commands
-LOGDIR         = \$(BASEDIR)/\$(SCRIPT_ROOT)/$LOGDIRBASE
-TESTLOGDIR     = \$(BASEDIR)/\$(SCRIPT_ROOT)/$TESTLOGDIRBASE
-
-crCMDSDIR      = /\$(SCRIPT_ROOT)/$PROGNAME-commands
-crLOGDIR       = /\$(SCRIPT_ROOT)/$LOGDIRBASE
-crTESTLOGDIR   = /\$(SCRIPT_ROOT)/$TESTLOGDIRBASE
-crFILELOGDIR   = /\$(SCRIPT_ROOT)/$FILELOGDIRBASE
-
+LUSER_HOME     = \$(LHOME)/\$(LUSER)
 SU_LUSER       = su - \$(LUSER) -c
-LUSER_HOME     = \$(LHOME)/\$(LUSER)
 
 ADD_REPORT       = $REPORT
@@ -58,20 +50,5 @@
 
 #----------------------------------#
-LUSER_wrt_target() {               # Create target
-#----------------------------------#
-  local i=$1
-  local PREV=$2
-(
-cat << EOF
-
-$i:  $PREV
-	@\$(call echo_message, Building)
-	@export BASHBIN=\$(SHELL) && \$(SHELL) progress_bar.sh \$@ \$\$PPID &
-EOF
-) >> $MKFILE.tmp
-}
-
-#----------------------------------#
-CHROOT_wrt_target() {              #
+wrt_target() {                     # Create target
 #----------------------------------#
   local i=$1
@@ -90,8 +67,8 @@
 
 
-#======== RUN AS =======
+#======== RUN THE SCRIPT =======
 
 #----------------------------------#
-wrt_RunAsRoot() {                  # Some scripts must be run as root..
+wrt_RunAsRoot() {                  # Some not-chroot scripts must be run as root..
 #----------------------------------#
   local MOUNT_ENV
@@ -109,5 +86,5 @@
 (
 cat << EOF
-	@export ${MOUNT_ENV}=\$(MOUNT_PT) && ${PROGNAME}-commands/`dirname $file`/\$@ > $LOGDIRBASE/\$@ 2>&1
+	@export ${MOUNT_ENV}=\$(MOUNT_PT) && \$(CMDSDIR)/`dirname $file`/\$@ > $LOGDIRBASE/\$@ 2>&1
 EOF
 ) >> $MKFILE.tmp
@@ -115,5 +92,5 @@
 
 #----------------------------------#
-LUSER_wrt_RunAsUser() {            #
+wrt_RunScript() {                  #
 #----------------------------------#
   local file=$1
@@ -126,16 +103,4 @@
 }
 
-#----------------------------------#
-CHROOT_wrt_RunAsRoot() {           #
-#----------------------------------#
-  local file=$1
-(
-cat << EOF
-	@\$(crCMDSDIR)/`dirname $file`/\$@ > $LOGDIRBASE/\$@ 2>&1
-EOF
-) >> $MKFILE.tmp
-
-}
-
 #=======================
 
@@ -144,5 +109,5 @@
 
 #----------------------------------#
-LUSER_wrt_CopyFstab() {            #
+LUSER_wrt_CopyFstab() {            # Needed for CLFS Sysroot and Embedded
 #----------------------------------#
 (
@@ -154,5 +119,5 @@
 
 #----------------------------------#
-CHROOT_wrt_CopyFstab() {           #
+wrt_CopyFstab() {                  #
 #----------------------------------#
 (
@@ -169,5 +134,5 @@
 
 #----------------------------------#
-LUSER_wrt_TouchTimestamp() {       #
+LUSER_wrt_TouchTimestamp() {       # Needed for CLFS Sysroot and Embedded
 #----------------------------------#
 (
@@ -179,5 +144,5 @@
 
 #----------------------------------#
-CHROOT_wrt_TouchTimestamp() {      #
+wrt_TouchTimestamp() {             #
 #----------------------------------#
 (
@@ -189,5 +154,5 @@
 
 #----------------------------------#
-LUSER_wrt_LogNewFiles() {          #
+LUSER_wrt_LogNewFiles() {          # Needed for CLFS Sysroot and Embedded
 #----------------------------------#
   local name=$1
@@ -200,5 +165,5 @@
 
 #----------------------------------#
-CHROOT_wrt_LogNewFiles() {         #
+wrt_LogNewFiles() {                #
 #----------------------------------#
   local name=$1