Index: LFS/lfs.xsl
===================================================================
--- LFS/lfs.xsl	(revision 570c9f386310c01d139bd9559fea68add16fd34b)
+++ LFS/lfs.xsl	(revision 51e3d236601db528e467eaa73e5120c359f0441c)
@@ -88,7 +88,8 @@
 VERSION=0.0.0
 TARBALL=dummy-0.0.0.tar.bz2
-      </xsl:text>
-      <xsl:call-template name="unpack"/>
-      <xsl:text>
+        </xsl:text>
+        <xsl:call-template name="disk_usage"/>
+        <xsl:call-template name="unpack"/>
+        <xsl:text>
 cd $PKGDIR
 ./configure --prefix=/usr
@@ -97,4 +98,5 @@
 make install
         </xsl:text>
+        <xsl:call-template name="disk_usage"/>
         <xsl:call-template name="clean_sources"/>
         <xsl:call-template name="footer"/>
@@ -124,7 +126,8 @@
 VERSION=0.0.0
 TARBALL=dummy-0.0.0.tar.bz2
-      </xsl:text>
-      <xsl:call-template name="unpack"/>
-      <xsl:text>
+        </xsl:text>
+        <xsl:call-template name="disk_usage"/>
+        <xsl:call-template name="unpack"/>
+        <xsl:text>
 cd $PKGDIR
 ./configure --prefix=/usr
@@ -133,4 +136,5 @@
 make install
         </xsl:text>
+        <xsl:call-template name="disk_usage"/>
         <xsl:call-template name="clean_sources"/>
         <xsl:call-template name="footer"/>
@@ -156,4 +160,5 @@
 TARBALL=dummy-0.0.0.tar.bz2
       </xsl:text>
+      <xsl:call-template name="disk_usage"/>
       <xsl:call-template name="unpack"/>
       <xsl:text>
@@ -164,4 +169,5 @@
 make install
       </xsl:text>
+      <xsl:call-template name="disk_usage"/>
       <xsl:call-template name="clean_sources"/>
       <xsl:call-template name="footer"/>
@@ -195,27 +201,48 @@
     <!-- Script header -->
   <xsl:template name="header">
-      <!-- Set the shabang -->
-    <xsl:choose>
-      <xsl:when test="@id='ch-system-creatingdirs' or
-                      @id='ch-system-createfiles' or
-                      @id='ch-system-strippingagain'">
-        <xsl:text>#!/tools/bin/bash&#xA;</xsl:text>
-      </xsl:when>
-      <xsl:otherwise>
-        <xsl:text>#!/bin/bash&#xA;</xsl:text>
-      </xsl:otherwise>
-    </xsl:choose>
-      <!-- Set +h -->
-    <xsl:text>set +h&#xA;</xsl:text>
-      <!-- Set -e -->
-    <xsl:if test="not(@id='ch-tools-stripping') and
-                  not(@id='ch-system-strippingagain')">
-      <xsl:text>set -e&#xA;</xsl:text>
-    </xsl:if>
-    <xsl:text>&#xA;</xsl:text>
-  </xsl:template>
-
-
-    <!-- Enter to the sources dir, clean it, and unpack the tarball -->
+    <xsl:if test="not(@id='ch-system-chroot') and
+                  not(@id='ch-system-revisedchroot')">
+        <!-- Set the shabang -->
+      <xsl:choose>
+        <xsl:when test="@id='ch-system-creatingdirs' or
+                        @id='ch-system-createfiles' or
+                        @id='ch-system-strippingagain'">
+          <xsl:text>#!/tools/bin/bash&#xA;</xsl:text>
+        </xsl:when>
+        <xsl:otherwise>
+          <xsl:text>#!/bin/bash&#xA;</xsl:text>
+        </xsl:otherwise>
+      </xsl:choose>
+        <!-- Set +h -->
+      <xsl:text>set +h&#xA;</xsl:text>
+        <!-- Set -e -->
+      <xsl:if test="not(@id='ch-tools-stripping') and
+                    not(@id='ch-system-strippingagain')">
+        <xsl:text>set -e&#xA;</xsl:text>
+      </xsl:if>
+        <!-- Dump a time stamp -->
+      <xsl:text>&#xA;echo -e "\n`date`\n"&#xA;</xsl:text>
+    </xsl:if>
+  </xsl:template>
+
+
+    <!-- Dump current disk usage -->
+  <xsl:template name="disk_usage">
+    <xsl:if test="not(@id='ch-system-chroot') and
+                  not(@id='ch-system-revisedchroot')">
+      <xsl:choose>
+        <xsl:when test="ancestor::chapter[@id='chapter-temporary-tools']">
+          <xsl:text>echo -e "\nKB: `du -skx --exclude=jhalfs --exclude=lost+found $LFS`\n"&#xA;</xsl:text>
+        </xsl:when>
+        <xsl:otherwise>
+          <xsl:text>echo -e "\nKB: `du -skx --exclude=jhalfs --exclude=lost+found /`\n"&#xA;</xsl:text>
+        </xsl:otherwise>
+      </xsl:choose>
+    </xsl:if>
+  </xsl:template>
+
+
+    <!-- Enter to the sources dir, clean it, unpack the tarball,
+         and reset the seconds counter -->
   <xsl:template name="unpack">
     <xsl:choose>
@@ -236,4 +263,5 @@
 fi
 tar -xf $TARBALL
+SECONDS=0
     </xsl:text>
   </xsl:template>
@@ -262,5 +290,5 @@
 
 
-    <!-- Remove sources and build dirs -->
+    <!-- Remove sources and build dirs, skipping it from seconds meassurament -->
   <xsl:template name="clean_sources">
     <xsl:choose>
@@ -273,6 +301,8 @@
     </xsl:choose>
     <xsl:text>
+SECS=$SECONDS
 rm -rf $PKGDIR
 rm -rf ${PKGDIR%-*}-build
+SECONDS=$SECS
     </xsl:text>
   </xsl:template>
@@ -281,11 +311,13 @@
     <!-- Script footer -->
   <xsl:template name="footer">
-      <!-- Dump the build time -->
+      <!-- Dump the build time and exit -->
     <xsl:if test="not(@id='ch-system-chroot') and
                   not(@id='ch-system-revisedchroot')">
-      <xsl:text>&#xA;&#xA;echo -e "\n\nTotalseconds: $SECONDS\n"&#xA;</xsl:text>
-    </xsl:if>
-      <!-- Exit -->
-    <xsl:text>&#xA;exit&#xA;</xsl:text>
+      <xsl:text>
+echo -e "\n\nTotalseconds: $SECONDS\n"
+
+exit
+      </xsl:text>
+    </xsl:if>
   </xsl:template>
 
@@ -350,4 +382,5 @@
 TARBALL=dummy-0.0.0.tar.bz2
       </xsl:text>
+      <xsl:call-template name="disk_usage"/>
       <xsl:call-template name="unpack"/>
       <xsl:text>
@@ -358,4 +391,5 @@
 make install
       </xsl:text>
+      <xsl:call-template name="disk_usage"/>
       <xsl:call-template name="clean_sources"/>
       <xsl:call-template name="footer"/>
@@ -454,4 +488,5 @@
           <xsl:with-param name="phase" select="$filename"/>
         </xsl:apply-templates>
+        <xsl:call-template name="disk_usage"/>
         <xsl:if test="sect2[@role='installation']">
           <xsl:call-template name="unpack"/>
@@ -462,4 +497,5 @@
         <xsl:call-template name="post_commands"/>
         <xsl:call-template name="user_footer"/>
+        <xsl:call-template name="disk_usage"/>
         <xsl:if test="sect2[@role='installation']">
           <xsl:call-template name="clean_sources"/>