Index: LFS/lfs.xsl
===================================================================
--- LFS/lfs.xsl	(revision 9c600120512f25fd859f2da14aaa46443bed3e56)
+++ LFS/lfs.xsl	(revision 66c3162389127d305a006058535e2365a0d25e52)
@@ -407,8 +407,8 @@
       <xsl:choose>
         <xsl:when test="ancestor::chapter[@id='chapter-temporary-tools']">
-          <xsl:text>echo -e "\nKB: `du -skx --exclude=jhalfs --exclude=lost+found $LFS`\n"&#xA;</xsl:text>
+          <xsl:text>&#xA;echo -e "\nKB: `du -skx --exclude=jhalfs --exclude=lost+found $LFS`\n"&#xA;</xsl:text>
         </xsl:when>
         <xsl:otherwise>
-          <xsl:text>echo -e "\nKB: `du -skx --exclude=jhalfs --exclude=lost+found /`\n"&#xA;</xsl:text>
+          <xsl:text>&#xA;echo -e "\nKB: `du -skx --exclude=jhalfs --exclude=lost+found /`\n"&#xA;</xsl:text>
         </xsl:otherwise>
       </xsl:choose>
Index: XSL/blfs-tool.xsl
===================================================================
--- XSL/blfs-tool.xsl	(revision 9c600120512f25fd859f2da14aaa46443bed3e56)
+++ XSL/blfs-tool.xsl	(revision 66c3162389127d305a006058535e2365a0d25e52)
@@ -13,4 +13,5 @@
       <!-- Fixed directory and ch_order values -->
     <xsl:variable name="basedir">blfs-tool-deps/30_</xsl:variable>
+
       <!-- libxml2 -->
     <exsl:document href="{$basedir}01-libxml2" method="text">
@@ -36,4 +37,5 @@
       <xsl:call-template name="footer"/>
     </exsl:document>
+
       <!-- libxslt -->
     <exsl:document href="{$basedir}02-libxslt" method="text">
@@ -59,4 +61,5 @@
       <xsl:call-template name="footer"/>
     </exsl:document>
+
       <!-- tidy -->
     <exsl:document href="{$basedir}03-tidy" method="text">
@@ -83,4 +86,5 @@
       <xsl:call-template name="footer"/>
     </exsl:document>
+
       <!-- unzip -->
     <exsl:document href="{$basedir}04-unzip" method="text">
@@ -108,4 +112,5 @@
       <xsl:call-template name="footer"/>
     </exsl:document>
+
       <!-- DocBook XML DTD -->
     <exsl:document href="{$basedir}05-docbook-xml" method="text">
@@ -125,4 +130,5 @@
 cd docbook-xml
 unzip ../docbook-xml-4.5.zip
+SECONDS=0
 install -v -d -m755 /usr/share/xml/docbook/xml-dtd-4.5
 install -v -d -m755 /etc/xml
@@ -222,9 +228,12 @@
       <xsl:call-template name="disk_usage"/>
       <xsl:text>
+SECS=$SECONDS
 cd /sources
 rm -rf docbook-xml
-      </xsl:text>
-      <xsl:call-template name="footer"/>
-    </exsl:document>
+SECONDS=$SECS
+      </xsl:text>
+      <xsl:call-template name="footer"/>
+    </exsl:document>
+
       <!-- DocBook XSL (empty and commented-out, it's not required for now) -->
     <!--<exsl:document href="{$basedir}06-docbook-xsl" method="text">
@@ -247,5 +256,6 @@
       <xsl:call-template name="footer"/>
     </exsl:document>-->
-      <!--  -->
+
+      <!-- gpm -->
     <exsl:document href="{$basedir}07-gpm" method="text">
       <xsl:call-template name="header"/>
@@ -277,5 +287,6 @@
       <xsl:call-template name="footer"/>
     </exsl:document>
-      <!--  -->
+
+      <!-- lynx -->
     <exsl:document href="{$basedir}08-lynx" method="text">
       <xsl:call-template name="header"/>
@@ -307,5 +318,6 @@
       <xsl:call-template name="footer"/>
     </exsl:document>
-      <!--  -->
+
+      <!-- sudo -->
     <exsl:document href="{$basedir}09-sudo" method="text">
       <xsl:call-template name="header"/>
@@ -335,5 +347,6 @@
       <xsl:call-template name="footer"/>
     </exsl:document>
-      <!--  -->
+
+      <!-- wget -->
     <exsl:document href="{$basedir}10-wget" method="text">
       <xsl:call-template name="header"/>
@@ -358,5 +371,6 @@
       <xsl:call-template name="footer"/>
     </exsl:document>
-      <!--  -->
+
+      <!-- subversion -->
     <exsl:document href="{$basedir}11-subversion" method="text">
       <xsl:call-template name="header"/>
Index: common/libs/func_book_parser
===================================================================
--- common/libs/func_book_parser	(revision 9c600120512f25fd859f2da14aaa46443bed3e56)
+++ common/libs/func_book_parser	(revision 66c3162389127d305a006058535e2365a0d25e52)
@@ -81,5 +81,5 @@
   echo -n "Extracting commands for"
 
-  # Dump the commands in shell script form from the HLFS book.
+  # Dump the commands in shell script form from the book.
   case ${PROGNAME} in
     clfs)
@@ -145,4 +145,6 @@
                  --stringparam page $PAGE \
                  --stringparam lang $LANG \
+                 --stringparam custom-tools $CUSTOM_TOOLS \
+                 --stringparam blfs-tool $BLFS_TOOL \
                  -o ./${PROGNAME}-commands/ $XSL $BOOK/index.xml >>$LOGDIR/$LOG 2>&1
       ;;
@@ -150,6 +152,4 @@
         exit 1 ;;
   esac
-
-  [[ "${BLFS_TOOL}" = "y" ]] && copy_blfs_deps_scripts
 
   echo "done"